## guitarix 0.35.6

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys, os, re, shutil
import Build, Utils, Options, Logs, Configure, Scripting
from Constants import HEXVERSION
from Configure import ConfigurationError
from TaskGen import feature
import wscript_dsp

# Waf version check, for global waf installs

try:
    from Constants import WAFVERSION
except:
    WAFVERSION='1.0.0'
if WAFVERSION[:3] != '1.5':
    print('Incompatible Waf, use 1.5')
    sys.exit (1)

# these variables are mandatory ('/' are converted automatically)
srcdir = '.'
blddir = 'build'
use_2to3 = True

# used by waf dist and waf build
VERSION='0.35.6'
APPNAME='guitarix'

good_faust_versions = ['0.9.58','0.9.65','0.9.73']

g_maxlen = 40 # maximum width of message for 2-column display


################################################################
# options defined for waf configure
################################################################

def set_options(opt):
    
    def add_enable_option (option, desc, group=None, disable=False):
        if group == None:
            group = opt
        option_ = option.replace ('-', '_')
        group.add_option ('--enable-' + option, action='store_true',
            default=False, help='Enable ' + desc, dest='enable_' + option_)
        group.add_option ('--disable-' + option, action='store_true',
            default=disable, help='Disable ' + desc, dest='disable_' + option_)

    opt.tool_options('gcov')
    opt.tool_options ('intltool')
    group = opt.add_option_group ('Localization and documentation', '')
    add_enable_option ('nls', 'native language support', group)

    opt.tool_options('compiler_cxx')
    comp = opt.get_option_group("--check-cxx-compiler")

    comp.add_option('--debug',
                    action='store_const',
                    default=False,
                    const=True,
                    help='set compiler flags for a debug build')

    comp.add_option('--cxxflags-release',
                    type='string',
                    default='-O3 -DNDEBUG',
                    dest='cxxflags_release',
                    help='additional C++ compiler flags for release version (not used if --debug) [Default: %default]')

    comp.add_option('--cxxflags-debug',
                    type='string',
                    default='-O2 -g -fstack-protector-all',
                    dest='cxxflags_debug',
                    help='additional C++ compiler flags for debug version (only used if --debug) [Default: %default]')

    comp.add_option('--cxxflags',
                    type='string',
                    default='-Wall', # -fomit-frame-pointer -ffast-math -fstrength-reduce -mmmx -mfpmath=sse -DUSE_XMMINTRIN -pipe
                    dest='cxxflags',
                    help='C++ base compiler flags [Default: %default]')

    comp.add_option('--disable-cxx11',
                    action='store_const',
                    default=False,
                    const=True,
                    help='deselect C++ compiler flag -std=c++11 [Default: False]')

    comp.add_option('--ldflags',
                    type='string',
                    default='', 
                    dest='ldflags',
                    help='C++ base linker flags ')

    comp.add_option('--enable-lfs',
                    action='store_const',
                    default=False, 
                    const=True,
                    help='enable Large File Support (LFS)  ')

    comp.add_option('--optimization',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='automatically select additional C++ compiler optimization flags for the current platform')

    comp.add_option('--no-desktop-update',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='dont automatically update desktop database')


    opt.recurse('libgxw/gxw')
    opt.recurse('libgxwmm/gxwmm')

    comp = opt.add_option_group("Additional Library Options")

    comp.add_option('--includeresampler',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-resample libary (Default NO)')

    comp.add_option('--includeconvolver',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-convolver libary (Default NO)')

    comp.add_option('--convolver-ffmpeg',
                    action='store_const',
                    default=False,
                    const=True,
                    help='modified zita-convolver libary that uses ffmpeg instead of fftw3 for FFT (Default NO)')

    comp.add_option('--libdir',
                   type='string',
                   default='', 
                   dest='libdir',
                   help=('library install path '),
                   )

    faust = opt.add_option_group("Faust-Compiler")

    if len(good_faust_versions) == 1:
        faust_vers_str = good_faust_versions[0]
    else:
        faust_vers_str = "in [%s]" % ", ".join(good_faust_versions)

    faust.add_option('--faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help=('use faust even if the installed version is not %s'
                           % faust_vers_str))

    faust.add_option('--no-faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help="don't use faust, use the pre-built files in faust-generated")

    faust.add_option('--faust-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help="build with faust, single precision")

    faust.add_option('--faust-vectorize',
                     action='store_const',
                     default=False,
                     const=True,
                     help="call faust with --vectorize")

    faust.add_option('--faust-vectorize-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help=("call faust with --vectorize for sources built"
                           "in single (float) precision"))

    faust.add_option('--faust-options', help="additional faust options")

    ladspa = opt.add_option_group("LADSPA Options (installing ladspa modules)")

    ladspa.add_option('--no-ladspa',
                    action='store_const',
                    default=False,
                    const=True,
                    help="don't build ladspa plugins (Default yes)")

    ladspa.add_option('--no-new-ladspa',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build with new ladspa plugins (Default yes)"))


    ladspa.add_option('--ladspadir',
                    type='string',
                    help='LADSPA plugin directory [Default: <prefix>/lib/ladspa]')

    lv2 = opt.add_option_group("LV2 Options (installing LV2 modules)")

    lv2.add_option('--lv2dir',
                    type='string',
                    help='LV2 plugin directory [Default: <prefix>/lib/lv2]')

    lv2.add_option('--no-lv2',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build new lv2 plugins (Default no)"))

    lv2.add_option('--no-lv2-gui',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build lv2 plugin GUI's (Default no)"))

    lv2.add_option('--lv2-only',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("build only the lv2 plugins (Default no)"))

    lv2.add_option('--no-mod-lv2',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't install MOD lv2 GUI's (Default no)"))

    lv2.add_option('--disable-sse',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("disable SSE for lv2 plugins (ARM)"))

    style = opt.add_option_group("Style Options (installing font)")
    
    style.add_option('--install-roboto-font',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("install the included roboto condensed font"))
    
    

    opt.recurse('pygxw')
    opt.recurse('glade-gxw')

    opt.tool_options('compiler_cc') # for pygxw and glade-gxw

    opt.add_option('--dist-tree',
                   type='string',
                   dest='dist_tree',
                   help=("option for 'dist' command: git tree-ish to build"
                         " the archive from [Default: %s]" % 'V%s' % VERSION))

    opt.sub_options('src/gx_head');


################################################################
# waf configure
################################################################

################################################################
# configuration display helper functions
#

def print_msg(msg, nl=True):
    s = sys.stdout
    if nl:
        t = "\n"
    else:
        t = " "
    s.write(msg+t)

# a bit of waf display formatting
def display_msg(msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status:
        print_msg("%s :" % msg.ljust(g_maxlen),False)
        Utils.pprint(color, status)
    else:
        print_msg("%s" % msg.ljust(g_maxlen))

def error_msg(msg):
    Utils.eprint('RED', msg)

def display_feature(msg, build):
    if build:
        display_msg(msg, "yes", 'CYAN')
    else:
        display_msg(msg, "no", 'YELLOW')

################################################################
# configuration utility functions
#

def option_enabled (option):
    if getattr (Options.options, 'enable_' + option):
        return True
    if getattr (Options.options, 'disable_' + option):
        return False
    return True

def append_optimization_flags(cxxflags):
    cpu_model = None
    x86_flags = None
    try:
        for line in open("/proc/cpuinfo"):
            if cpu_model is None:
                if line.startswith("model name"):
                    cpu_model = line.split(":",1)[1].strip()
            elif x86_flags is None:
                if line.startswith("flags"):
                    x86_flags = line.split(":",1)[1].strip()
            else:
                break
    except IOError:
        pass
    if cpu_model is None or x86_flags is None:
        display_msg("Checking CPU Architecture",
                    "cpu model not found in /proc/cpuinfo",
                    "YELLOW")
        return None
    model = cpu_model.split()
    arch = os.uname()[4]
    if "AMD" in model and "x86_64" in arch:
        cxxflags.append ("-march=k8")
    elif "AMD" in model and "Sempron(tm)" in model:
        cxxflags.append ("-march=native")
    elif "Geode" in model :
        cxxflags.append ("-march=geode")
    elif "Core" in model and "x86_64" in arch:
        cxxflags.append ("-march=core2")
    elif "i386" in arch:
        cxxflags.append ("-march=i386")
    elif "i486" in arch:
        cxxflags.append ("-march=i486")
    elif "i586" in arch:
        cxxflags.append ("-march=i586")
    elif "i686" in arch:
        cxxflags.append ("-march=i686")
    else:
        cxxflags.append ("-march=native")

    if "mmx" in x86_flags:
        cxxflags.append ("-mmmx")

=== rcstyles/wscript ===
#!/usr/bin/env python
# encoding: utf-8

gxstyle_files = [
    'gx_head_Guitarix.rc',
    'background1.png',
    'background2.png',
    'live_wallpaper_aluminium.png',
    'live_wallpaper_camouflage.png',
    'live_wallpaper_copper.png',
    'live_wallpaper_dark.png',
    'live_wallpaper.png',
    'live_wallpaper_guitarix_oak.png',
    'live_wallpaper_lavender.png',
    'live_wallpaper_oak.png',
    'live_wallpaper_olive.png',
    'live_wallpaper_orange.png',
    'live_wallpaper_sky.png',
    'live_wallpaper_white_oak.png',
    'live_wallpaper_burl.png',
    'live_wallpaper_psycedelic.png',
    'live_wallpaper_hippie.png',
    'live_wallpaper_grungy_sun.png',
    'live_wallpaper_grungy_sun_dark.png',
    'live_wallpaper_grandma.png',
    'live_wallpaper_nebula.png',
    'live_wallpaper_rust.png',
    
    'clear.rc',
    'tactile_knob_large_151f.png',
    'tactile_knob_small_99f.png',
    'tactile_knob_medium_151f.png',
    'tactile_wheel_101f.png',

    'stereo.png',
    'live_bypass.png',
    'factory.png',
    'live_mute.png',
    'readonly.png',
    'scratch.png',
    'versiondiff.png',
    'playhead.png',
    'simplelevelslider.png',

    'switch_on.png',
    'switch_mid_off.png',
    'switch_mid_on.png',
    'switch_off.png',
    'rack_expand.png',
    'rack_shrink.png',
    'rack_preset.png',
    'rack_preset.png',
    'insert.png',
    'hslider.png',
    'logo.png',
    'logo_orange.png',
    'logo_white.png',
    'handle_left.png',
    'handle_right.png',

    # knobs
    'knob_small.png',
    'knob_small_r.png',
    'knob_mid.png',
    'knob_big.png',
    
    ###COPPER THEME
    'gx_head_Copper.rc',
    'copper.png',
    
    ###LAVENDER THEME
    'gx_head_Lavender.rc',
    'lavender.png',
    
    ###SKY THEME
    'gx_head_Sky.rc',
    'sky.png',
    
    ###OLIVE THEME
    'gx_head_Olive.rc',
    'olive.png',
    
    ###HIPPIE THEME
    'gx_head_Hippie.rc',
    'hippie.png',
    'hippie2.png',
    'knob_small_hippie.png',
    'knob_small_r_hippie.png',
    'knob_mid_hippie.png',
    'knob_big_hippie.png',
    
    ###PSYCEDELIC THEME
    'gx_head_Psycedelic.rc',
    'psycedelic.png',
    
    ###GRANDMA THEME
    'gx_head_Grandma.rc',
    'grandma.png',
    
    ###GRUNGY SUN THEME
    'gx_head_Grungy_Sun_Dark.rc',
    'grungy_sun_dark.png',
    'grungy_sun_dark2.png',
    
    ###GRUNGY SUN THEME
    'gx_head_Grungy_Sun.rc',
    'grungy_sun.png',
    'grungy_sun2.png',
    
    ###ALUMINIUM THEME
    'gx_head_Aluminium.rc',
    'aluminium1.png',
    'aluminium2.png',
    
    ###OAK THEME
    'gx_head_Oak.rc',
    'oak1.png',
    'oak2.png',
    
    ###BURL THEME
    'gx_head_Burl.rc',
    'burl1.png',
    'burl2.png',
    
    ###WHITE OAK THEME
    'gx_head_White_Oak.rc',
    'oak_white.png',
    #'oak2.png',
    
    ###GUITARIX OAK THEME
    'gx_head_Guitarix_Oak.rc',
    'oak_green.png',
    #'oak2.png',
    
    ###DARK THEME
    'gx_head_Plain_Dark.rc',
    'gx_head_Dark.rc',
    'dark.png',

    ###NEBULA THEMA
    'gx_head_Nebula.rc',
    'nebula.png',
    'nebula2.png',

    ###CAMOUFLAGE THEME
    'gx_head_Camouflage.rc',
    'camouflage.png',
    
    ###ORANGE THEME
    'gx_head_Orange.rc',
    'orange.png',
    
    ###WOOD THEME
    'gx_head_Rust.rc',
    'rust.png',
    'rust2.png',
    
     ]

def configure(conf):
    pass

def build(bld):
    bld.install_files(bld.env['GX_STYLE_DIR'], gxstyle_files, chmod=0o644)

=== src/faust/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import wscript_helper

def build(bld):
    unused_sources = [
        'preamp.dsp',
        'inputgain.dsp',
        'AntiAlias.dsp',
        'HighShelf.dsp',
        'drive.dsp',
        'osc_tube.dsp',
        'reso_tube.dsp',
        'tube.dsp',
        'tube3.dsp',
        'tubevibrato.dsp',
        'multifilter.dsp',
        'eq.dsp',
        'outputgain.dsp',
        'feed.dsp',
        'balance1.dsp',
        'amp2.dsp',
        'stage3.dsp',
        'distortion.dsp',
        'distortion1.dsp',
        'noisegate.dsp',
        'sloop.dsp', ##float
        'vibe_lfo_triangle.dsp',
        'vibe_mono_lfo_triangle.dsp',
        ]

    sources_float = [
        'jconv_post.dsp',
        ]

    sources = [
        'jconv_post_mono.dsp',
        'presence_level.dsp',
        'cabinet_impulse_former.dsp',
        'cabinet_impulse_former_st.dsp',
        'preamp_impulse_former.dsp',
        ]

    sources_static = [
        'vibe_mono_lfo_sine.dsp',
        'vibe_lfo_sine.dsp',
        ]

    sources_plugin_float = [
        'echo.dsp',
        'delay.dsp',
        'chorus.dsp',
        'chorus_mono.dsp',
        'stereodelay.dsp',
        'stereoecho.dsp',
        'digital_delay.dsp',
        'digital_delay_st.dsp',
        'phaser.dsp',
        'phaser_mono.dsp',
        'crybaby.dsp',
        'autowah.dsp',
        ]

    sources_plugin_double = [
        'selecteq.dsp',

        # tone stacks
        'tonestack_default.dsp',  # this one also ok in single precision
        'tonestack_bassman.dsp',
        'tonestack_twin.dsp',
        'tonestack_princeton.dsp',
        'tonestack_jcm800.dsp',
        'tonestack_jcm2000.dsp',
        'tonestack_mlead.dsp',
        'tonestack_m2199.dsp',
        'tonestack_ac30.dsp',
        'tonestack_soldano.dsp',
        'tonestack_mesa.dsp',
        'tonestack_jtm45.dsp',
        'tonestack_ac15.dsp',
        'tonestack_peavey.dsp',
        'tonestack_ibanez.dsp',
        'tonestack_roland.dsp',
        'tonestack_ampeg.dsp',
        'tonestack_ampeg_rev.dsp',
        'tonestack_sovtek.dsp',
        'tonestack_bogner.dsp',
        'tonestack_groove.dsp',
        'tonestack_crunch.dsp',
        'tonestack_fender_blues.dsp',
        'tonestack_fender_default.dsp',
        'tonestack_fender_deville.dsp',
        'tonestack_gibsen.dsp',
        'tonestack_engl.dsp',
        ]

    sources_plugin = [
        'low_high_pass.dsp',
        'gx_distortion.dsp',
        'bitdowner.dsp',
        'impulseresponse.dsp',
        'compressor.dsp',
        'expander.dsp',
        'overdrive.dsp',
        'freeverb.dsp',
        'biquad.dsp',
        'tremolo.dsp',
        'flanger_mono.dsp',
        'gx_feedback.dsp',
        'flanger.dsp',
        'moog.dsp',
        'gx_ampmodul.dsp',
        'tonecontroll.dsp',
        'stereoverb.dsp',
        'softclip.dsp',
        'gx_ampout.dsp',
        'gx_ampout_ladspa.dsp',
        'noise_shaper.dsp',
        'bassbooster.dsp',
        'gx_outputlevel.dsp',
        'gx_outputlevel_ladspa.dsp',
        'gxfeed.dsp',
        'highbooster.dsp',
        'peak_eq.dsp',
        'dattorros_progenitor.dsp',
        'ring_modulator.dsp',
        'ring_modulator_st.dsp',
        'panoram_enhancer.dsp',
        'graphiceq.dsp',
        'bass_enhancer.dsp',
        'gain.dsp',
        'duck_delay.dsp',
        'duck_delay_st.dsp',
        'baxandall.dsp',
        'distortion2.dsp',
        'fuzzface.dsp',
        'trbuff.dsp',
        'colwah.dsp',
        'dallaswah.dsp',
        'foxwah.dsp',
        'maestrowah.dsp',
        'voxwah.dsp',
        'selwah.dsp',
        'jenwah.dsp',
        'colbwah.dsp',
        'rolwah.dsp',
        'jenbasswah.dsp',


        # amps
        'gxamp.dsp',
        'gxamp2.dsp',
        'gxamp3.dsp',
        'gxamp4.dsp',
        'gxamp5.dsp',
        'gxamp6.dsp',
        'gxamp7.dsp',
        'gxamp8.dsp',
        'gxamp9.dsp',
        'gxamp10.dsp',
        'gxamp11.dsp',
        'gxamp12.dsp',
        'gxamp13.dsp',
        'gxamp14.dsp',
        'gxamp15.dsp',
        'gxamp16.dsp',
        'gxamp17.dsp',
        'gxamp18.dsp',
        'gxnoamp.dsp',

        # bypass mode
        'balance.dsp',
        ]

    if bld.env['FAUST']:
        arg, float_arg, double_arg = wscript_helper.get_faust_args(bld)
        bld.new_task_gen(
            source = sources,
            proc = "../tools/dsp2cc",
            separate_header = True,
            proc_args = arg+["--init-type=no-init-instance"],
            )
        bld.new_task_gen(
            source = sources_float,
            proc = "../tools/dsp2cc",
            separate_header = True,
            proc_args = float_arg+["--init-type=no-init-instance"],
            )
        bld.new_task_gen(
            source = sources_static,
            proc = "../tools/dsp2cc",
            proc_args = arg+["--init-type=no-init"],
            )
        bld.new_task_gen(
            source = sources_plugin,
            proc = "../tools/dsp2cc",
            proc_args = arg+["--init-type=plugin-instance"],
            )
        bld.new_task_gen(
            source = sources_plugin_float,
            proc = "../tools/dsp2cc",
            proc_args = float_arg+["--init-type=plugin-instance"]
            )
        bld.new_task_gen(
            source = sources_plugin_double,
            proc = "../tools/dsp2cc",
            proc_args = double_arg+["--init-type=plugin-instance"]
            )
    else:
        gdir = "../faust-generated/"
        for s in (sources + sources_static + sources_float +
                  sources_plugin_float + sources_plugin_double + sources_plugin):
            s = s.replace(".dsp",".cc")
            bld(name = "copy-faust-cc",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
                )
        for s in sources + sources_float:
            s = s.replace(".dsp",".h")
            bld(name = "copy-faust-h",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
                )
    bld.add_group()

def configure(conf):
    pass

=== src/gx_head/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys, wscript_helper
import Task, Utils, Options, Logs, os, shutil
from TaskGen import extension

def set_options(opt):
    guitarix_prog = opt.add_option_group("Guitarix Program Options")
    guitarix_prog.add_option(
        '--no-avahi', action='store_const', default=False, const=True,
        help=('Do not build with avahi support for automatic discovery of'
              ' / connection to Guitarix server instances  [Default: no]'))
    guitarix_prog.add_option(
        '--no-bluez', action='store_const', default=False, const=True,
        help=('Do not build with bluez support for remote'
              ' / connection to Guitarix server instances  [Default: no]'))

def configure(conf):
    if not Options.options.no_avahi:
        conf.check_cfg(package='avahi-gobject', args='--cflags --libs', uselib_store='AVAHI_GOBJECT', mandatory=1)
        conf.check_cfg(package='avahi-glib', args='--cflags --libs', uselib_store='AVAHI_GLIB', mandatory=1)
        conf.check_cfg(package='avahi-client', args='--cflags --libs', uselib_store='AVAHI_CLIENT', mandatory=1)
        conf.define("HAVE_AVAHI", 1)
    if not Options.options.no_bluez:
        conf.check_cfg(package='bluez', args='--cflags --libs', uselib_store='BLUEZ', mandatory=0)

def gperf2cc(task):
    out_c = task.outputs[0].bldpath(task.env)
    out_h = task.outputs[1].bldpath(task.env)
    basename = os.path.splitext(
        os.path.basename(task.inputs[0].srcpath(task.env)))[0]
    srcdir = task.inputs[0].parent.srcpath(task.env)
    if task.env["HAVE_GPERF"]:
        cmd = [task.proc,
               task.inputs[0].srcpath(task.env),
               out_c,
               out_h,
               ]
        Logs.debug("runner: system command -> %s" % cmd)
        ret = Utils.exec_command(cmd, shell=False)
        shutil.copy2(out_c, os.path.join(srcdir, basename+"-generated.cc"))
        shutil.copy2(out_h, os.path.join(srcdir, basename+"-generated.h"))
        return ret
    else:
        shutil.copy2(os.path.join(srcdir, basename+"-generated.cc"), out_c)
        shutil.copy2(os.path.join(srcdir, basename+"-generated.h"), out_h)
        return 0

Task.task_type_from_func(
    'gperf',
    gperf2cc,
    color='BLUE',
    before='cc cxx',
    )

@extension('.gperf_tmpl')
def process_gperf_tmpl(self, node):
    cc_node = node.change_ext('.cc')
    h_node = node.change_ext('.h')
    task = self.create_task('gperf', [node], [cc_node, h_node])
    task.proc = "../tools/make_jsonrpc_methods"
    self.bld.add_manual_dependency(node,self.bld.bldnode.find_resource(task.proc))

def build(bld):
    sources_engine = [
        './engine/gx_logging.cpp',
        './engine/gx_pluginloader.cpp',
        './engine/ladspaplugin.cpp',
        './engine/ladspaback.cpp',
        './engine/tunerswitcher.cpp',
        './engine/jsonrpc.cpp',
        './engine/gx_jack.cpp',
        './engine/gx_preset.cpp',
        './engine/gx_json.cpp',
        './engine/gx_faust_plugins.cpp',
        './engine/gx_internal_plugins.cpp',
        './engine/gx_internal_ui_plugins.cpp',
        './engine/gx_midi_plugin.cpp',
        './engine/gx_engine_audio.cpp',
        './engine/gx_paramtable.cpp',
        './engine/gx_pitch_tracker.cpp',
        './engine/gx_convolver.cpp',
        './engine/gx_resampler.cpp',
        './engine/gx_system.cpp',
        './engine/gx_engine.cpp',
        './engine/gx_engine_midi.cpp',
        './engine/jsonrpc_methods.gperf_tmpl',
        ]

    sources_gui = [
        './gui/machine.cpp',
        './gui/ladspalist.cpp',
        './gui/gx_stackbox_builder.cpp',
        './gui/gx_main_window.cpp',
        './gui/liveplay.cpp',
        './gui/rack.cpp',
        './gui/gx_preset_window.cpp',
        './gui/gx_jack_options.cpp',
        './gui/gx_ui_builder.cpp',
        './gui/gx_gui_helpers.cpp',
        './gui/gx_child_process.cpp',
        './gui/gx_main_midi.cpp',
        './gui/gx_jconv_settings.cpp',
        './gui/gx_sequencer_settings.cpp',
        './gui/gxw_mm_controllers.cpp',
        './gui/gx_main_boxes.cpp',
        './gui/gx_mono_rack_builder.cpp',
        './gui/gx_stereo_rack_builder.cpp',
        './gui/gx_cairo_callbacks.cpp',
        './gui/gx_portmap.cpp',
        './gui/gx_main.cpp',
        ]

    builder_files = [
        './builder/midi.glade',
        './builder/ports.glade',
        './builder/iredit.glade',
        './builder/iredit_mono.glade',
        './builder/jackstarter.glade',
        './builder/mainpanel.glade',
        './builder/ladspaliste.glade',
        './builder/crybaby_ui.glade',
        './builder/wah_ui.glade',
        './builder/vibe_ui.glade',
        './builder/vibe_stereo_ui.glade',
        './builder/reversedelay_ui.glade',
        './builder/gx_distortion_ui.glade',
        './builder/gx_record_ui.glade',
        './builder/gx_st_record_ui.glade',
        './builder/gx_detune_ui.glade',
        './builder/amp.tonestack_ui.glade',
        './builder/ampimpulse_ui.glade',
        './builder/cabinet_ui.glade',
        './builder/cabinet_stereo_ui.glade',
        './builder/tremolo_ui.glade',
        './builder/pluginpreset_inputwindow.glade',
        './builder/pluginpreset_listwindow.glade',
        './builder/selectinstance.glade',
        './builder/Sequencer.glade',
        './builder/menudef.xml',
        './builder/accels_rc',
        './builder/gx_plugins.png',
        './builder/gx_rack.png',
        './builder/gx_show.png',
        './builder/gx_split.png',
        './builder/gx_tuner.png',
        './builder/gx_config.png',
        './builder/gx_fold.png',
        './builder/gx_fullscreen.png',
        ]

    if bld.env["HAVE_AVAHI"]:
        sources_gui.append("gui/avahi_discover.cpp")
        sources_engine.append("engine/avahi_register.cpp")
    sources = sources_engine + sources_gui
    incl = ['.','./engine','../..','..','../headers','../../libgxwmm','../../libgxw'] # need ".." for config.h
    libpath = []
    lib = []
    if not sys.platform.startswith("darwin"):
        lib.append('dl')
    uselib = ['JACK', 'SNDFILE', 'GTHREAD', 'GMODULE_EXPORT',
              'GTK2', 'GTKMM', 'GIOMM', 'FFTW3', 'LRDF', 'LILV', 'BOOST_SYSTEM']
    if bld.env["HAVE_AVAHI"]:
        uselib += ['AVAHI_GOBJECT', 'AVAHI_GLIB', 'AVAHI_CLIENT']
    if bld.env["HAVE_BLUEZ"]:
        uselib.append('BLUEZ')
    uselib_local = []
    wscript_helper.add_zita_convolver(bld, uselib, sources, incl)
    wscript_helper.add_zita_resampler(bld, uselib, sources, incl)
    if bld.env["HAVE_PLUGINLIB"]:
        uselib_local += ["plugins"]
    if bld.env["GX_LIB_SHARED"]:
        lib += ['gxwmm','gxw']
        libpath += [bld.path.find_dir("../../libgxw/gxw").bldpath(bld.env),
                    bld.path.find_dir("../../libgxwmm/gxwmm").bldpath(bld.env)]
    else:
        uselib_local += ['gxwmm','gxw']
    ldscript = bld.path.find_resource('guitarix.lds')
    mapfile = bld.path.find_or_declare("guitarix.map")
    task = bld(features = 'cxx cprogram',
        includes = incl,
        obj_ext  = '.o',
        source = sources,
        lib = lib,
        uselib = uselib,
        uselib_local = uselib_local,
        libpath = libpath,
        target = bld.env['BIN_NAME'],
        chmod = 0o755,
        install_path = bld.env['BINDIR'],
        ldflags = ['-Wl,%s,-Map=%s' % (ldscript.srcpath(),mapfile.bldpath(bld.env))],
        )
    bld.add_manual_dependency(bld.path.find_or_declare(task.target), ldscript)
    bld.install_files(bld.env['GX_BUILDER_DIR'], builder_files, chmod=0o644)

=== src/plugins/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import os, wscript_helper

csources = [ # generate .so files from c sources that can be loaded by guitarix
    # element = name or [name, [lib, ...]]
    
    ]

sources = [ # generate .so files that can be loaded by guitarix
    #"dunwah.dsp",
    ]

lib_csource_defs = [ # put in static library linked with guitarix
    ["vibe.cc", ("plugin_mono", "plugin_stereo")],
    #"dubbe.cc",
    "metronome.cc",
    "abgate.cc",
    "jcm800pre.cpp",
    "reversedelay.cc",
    ]

lib_float_sources = [ # put in static library linked with guitarix
    #"dubber.dsp",
    ]
lib_sources = [ # put in static library linked with guitarix
    "zita_rev1.dsp",
    "ts9sim.dsp",
    "flanger_gx.dsp",
    "mbc.dsp",
    "mbcs.dsp",
    "mbd.dsp",
    "mbe.dsp",
    "mbdel.dsp",
    "mbchor.dsp",
    "mbclipper.dsp",
    "gcb_95.dsp",
    "fuzzfacerm.dsp",
    "fuzzfacefm.dsp",
    "hfb.dsp",
    "muff.dsp",
    "susta.dsp",
    "scream.dsp",
    "hornet.dsp",
    "foxeylady.dsp",
    "lpbboost.dsp",
    "hogsfoot.dsp",
    "cstb.dsp",
    "coverd.dsp",
    "rangem.dsp",
    "ruin.dsp",
    "ffreak.dsp",
    "fumaster.dsp",
    "fuzzdrive.dsp",
    "rolandwah.dsp",
    "astrofuzz.dsp",
    "buffb.dsp",
    "eldist.dsp",
    "mole.dsp",
    "buzz.dsp",
    "bfuzz.dsp",
    "axface.dsp",
    "aclipper.dsp",
    "bmp.dsp",
    "mxrdist.dsp",
    "bossds1.dsp",
    "bassboom.dsp",
    ]

def build(bld):
    if bld.env['FAUST']:
        arg, float_arg, double_arg = wscript_helper.get_faust_args(bld)
        arg += ["--init-type=plugin-instance"]
        bld(name = "dsp2cc sharedlib",
            source = sources,
            proc = "../tools/dsp2cc",
            gen_dir_suffix = "/generated",
            proc_args = arg+["--template-type=sharedlib"],
            )
        bld(name = "dsp2cc staticlib",
            source = lib_sources,
            proc = "../tools/dsp2cc",
            gen_dir_suffix = "/generated",
            proc_args = arg+["--template-type=staticlib","--in-namespace=pluginlib"],
            )
        bld(name = "dsp2cc staticlib",
            source = lib_float_sources,
            proc = "../tools/dsp2cc",
            gen_dir_suffix = "/generated",
            proc_args = float_arg+["--template-type=staticlib","--in-namespace=pluginlib","--init-type=plugin-instance"],
            )
    else:
        gdir = "generated/"
        for s in sources+lib_sources:
            s = s.replace(".dsp",".cc")
            bld(name = "copy-faust-plugin-cc",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
            )
    lib_csources = [v if isinstance(v, str) else v[0] for v in lib_csource_defs]
    lib_dict = dict([v for v in lib_csource_defs if not isinstance(v, str)])
    def run(task):
        l = []
        for fname in lib_sources+lib_csources:
            name = os.path.splitext(fname)[0]
            if fname in lib_dict:
                for pname in lib_dict[fname]:
                    l.append("namespace %s { PluginDef *%s(); }\n" % (name, pname))
            else:
                l.append("namespace %s { PluginDef *plugin(); }\n" % name)
        f = open(task.outputs[0].bldpath(task.env),"w")
        f.write('#include "gx_plugin.h"\n\nnamespace pluginlib {\n')
        f.write("".join(l))
        f.write("}\n")
        f.close()
    bld(name = "pluginlib.h",
        source = "wscript",
        rule = run,
        target = "pluginlib.h",
        )
    bld.add_group()
    have_pluginlib = len(lib_sources) != 0
    bld.env["HAVE_PLUGINLIB"] = have_pluginlib
    incl = [".","../headers", "../gx_head/engine"]
    if not bld.env['ZITA_RESAMPLER']:
        incl.append('../zita-resampler-1.1.0')
    
    if have_pluginlib:
        bld(features = ['cxx', 'cstaticlib'],
            includes = incl,
            source = [s.replace(".dsp",".cc") for s in lib_sources]+lib_csources,
            uselib = ["EIGEN3"],
            target = "plugins", # (also defines name of task)
            )
    for s in sources:
        tsk = bld(name = "create plugin .so",
            features = ['cxx', 'cshlib'],
            type = 'cshlib',
            cxxflags = ["-fvisibility=hidden"],
            includes = [".","../headers", "../gx_head/engine"],
            source = [s.replace(".dsp",".cc")],
            target = s.replace(".dsp",""),
            )
        tsk.env['shlib_PATTERN'] = '%s.so'
    for s in csources:
        if not isinstance(s, str):
            uselib = s[1]
            s = s[0]
        else:
            uselib = []
        tsk = bld(name = "create plugin .so",
            features = ['cxx', 'cshlib'],
            type = 'cshlib',
            cxxflags = ["-fvisibility=hidden"],
            includes = ["../headers", "../gx_head/engine"],
            source = s,
            target = s.replace(".cc",""),
            uselib = uselib,
            install_path = None, # for now...
            )
        tsk.env['shlib_PATTERN'] = '%s.so'

def configure(conf):
    conf.check_cfg(package='eigen3', args='--cflags', uselib_store="EIGEN3", mandatory=1)

=== src/LV2/gxtape.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes

def configure(conf):
    pass

def build(bld):
    bundle = 'gxtape.lv2'
    
    src = ['gxtape.cpp'
           ]
    incl = ['../faust','./', '../DSP']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['LV2CORE']
    cxxflag =[]
    if not bld.env['OPT'] and bld.env['SSE2']:
        cxxflag = [ "-msse2", "-mfpmath=sse"]
    lv2_effects = bld(
        features='cxx cshlib ',
        includes = incl,
        lib = lib,
        uselib = uselib,
        obj_ext  = '_5.o',
        cxxflags = cxxflag,
        defines  = ["LV2_SO"],
        target   = 'gxtape',
        source   = src,
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        )
    lv2_effects.env['shlib_PATTERN'] = '%s.so'
    
    uselib_local5 = []
    libpath5 = []
    lib5 = []
    incl5 = ['../../../libgxwmm','../../../libgxw','../']
    if sys.platform.startswith("linux"):
        lib5.append('dl')
    if bld.env["GX_LIB_SHARED"]:
        lib5 += ['gxwmm','gxw']
        libpath5 += [bld.path.find_dir("../../../libgxw/gxw").bldpath(bld.env),
                    bld.path.find_dir("../../../libgxwmm/gxwmm").bldpath(bld.env)]
    else:
        uselib_local5 += ['gxwmm','gxw']
    
    lv2_effetcs_gui = bld(
        features='cxx cshlib ',
        includes = incl5,
        lib = lib5,
        uselib = 'LV2CORE GTKMM',
        libpath = libpath5,
        uselib_local = uselib_local5,
        linkflags = '-Wl,-z,nodelete',
        defines  = ["LV2_GUI"],
        target   = 'gxtape_gui',
        source   = 'widget.cpp gxtape_gui.cpp',
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        )
    lv2_effetcs_gui.env['shlib_PATTERN'] = '%s.so'

    
    install_path = '${LV2DIR}/%s' % bundle,
    bld.install_files('${LV2DIR}/gxtape.lv2', 'manifest.ttl')
    bld.install_files('${LV2DIR}/gxtape.lv2', 'gxtape.ttl')

=== src/LV2/gxtape_st.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes

def configure(conf):
    pass

def build(bld):
    bundle = 'gxtape_st.lv2'
    
    src = ['gxtape_st.cpp'
           ]
    incl = ['../faust','./', '../DSP']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['LV2CORE']
    cxxflag =[]
    if not bld.env['OPT'] and bld.env['SSE2']:
        cxxflag = [ "-msse2", "-mfpmath=sse"]
    lv2_effects = bld(
        features='cxx cshlib ',
        includes = incl,
        lib = lib,
        uselib = uselib,
        obj_ext  = '_5.o',
        cxxflags = cxxflag,
        defines  = ["LV2_SO"],
        target   = 'gxtape_st',
        source   = src,
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        )
    lv2_effects.env['shlib_PATTERN'] = '%s.so'
    
    uselib_local5 = []
    libpath5 = []
    lib5 = []
    incl5 = ['../../../libgxwmm','../../../libgxw','../']
    if sys.platform.startswith("linux"):
        lib5.append('dl')
    if bld.env["GX_LIB_SHARED"]:
        lib5 += ['gxwmm','gxw']
        libpath5 += [bld.path.find_dir("../../../libgxw/gxw").bldpath(bld.env),
                    bld.path.find_dir("../../../libgxwmm/gxwmm").bldpath(bld.env)]
    else:
        uselib_local5 += ['gxwmm','gxw']
    
    lv2_effetcs_gui = bld(
        features='cxx cshlib ',
        includes = incl5,
        lib = lib5,
        uselib = 'LV2CORE GTKMM',
        libpath = libpath5,
        uselib_local = uselib_local5,
        linkflags = '-Wl,-z,nodelete',
        defines  = ["LV2_GUI"],
        target   = 'gxtape_st_gui',
        source   = 'widget.cpp gxtape_st_gui.cpp',
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        )
    lv2_effetcs_gui.env['shlib_PATTERN'] = '%s.so'

    
    install_path = '${LV2DIR}/%s' % bundle,
    bld.install_files('${LV2DIR}/gxtape_st.lv2', 'manifest.ttl')
    bld.install_files('${LV2DIR}/gxtape_st.lv2', 'gxtape_st.ttl')

=== debian/changelog ===
guitarix (0.35.6-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * New upstream release.
    - Drop dependency on WebKit (Closes: #866641)
    - Fix build issues with GCC 7. (Closes: #853437)
  * debian/control:
    - Bump Priority to optional.
    - Bump Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 12 Aug 2017 01:43:19 +0200

guitarix (0.35.3-1) experimental; urgency=medium

  * New upstream version 0.35.3
  * Update years in d/copyright

 -- Víctor Cuadrado Juan <me@viccuad.me>  Mon, 22 May 2017 21:17:22 +0200

=== debian/control ===
Source: guitarix
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Víctor Cuadrado Juan <me@viccuad.me>
Build-Depends: debhelper (>= 9),
               intltool,
               ladspa-sdk,
               libavahi-gobject-dev,
               libbluetooth-dev [linux-any],
               libboost-dev (>= 1.53),
               libboost-system-dev (>= 1.53),
               libboost-thread-dev (>= 1.53),
               libeigen3-dev,
               libgtk2.0-dev,
               libgtkmm-2.4-dev,
               libjack-dev,
               liblilv-dev,
               liblrdf0-dev,
               libsndfile1-dev,
               libzita-convolver-dev,
               libzita-resampler-dev,
               lv2-dev,
               python,
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 4.0.1
Homepage: http://guitarix.sourceforge.net/
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/guitarix.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/guitarix.git

Package: guitarix
Architecture: any
Depends: fonts-roboto,
         gtk2-engines,
         gtk2-engines-pixbuf,
         guitarix-common (= ${source:Version}),
         guitarix-ladspa (>= ${source:Version}),
         guitarix-lv2 (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: jack-capture, lame, vorbis-tools
Description: Rock guitar amplifier for Jack
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It provides one JACK input port and two JACK output
 ports. It is designed to produce nice trash/metal/rock/blues guitar sounds.
 Controls for bass, treble, gain, compressor, tube selector, distortion,
 flanger, freeverb, crybaby (wah), etc are available.
 .
 Guitarix comes with a GTK+ interface and as Ladspa and LV2 plugins.

Package: guitarix-common
Architecture: all
Multi-Arch: foreign
Breaks: guitarix (<< 0.35)
Replaces: guitarix (<< 0.35)
Depends: ${misc:Depends}
Description: Guitarix - Common files
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains Guitarix's Architecture independent files. Examples of
 such shared files are: configuration files, images and sounds.

Package: guitarix-ladspa
Architecture: any
Breaks: guitarix (<< 0.35)
Replaces: guitarix (<< 0.35)
Provides: ladspa-plugin
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Guitarix - ladspa plugins
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains the ladspa audio plugins that come together with
 guitarix, but can also be used by any other ladspa host.

Package: guitarix-lv2
Architecture: any
Breaks: guitarix (<< 0.35)
Replaces: guitarix (<< 0.35)
Provides: lv2-plugin
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Guitarix - LV2 plugins
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains the LV2 audio plugins that come together with guitarix,
 but can also be used by any other LV2 host.

Package: guitarix-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Priority: optional
Depends: libjs-jquery, ${misc:Depends}
Suggests: guitarix
Description: Guitarix - Development documentation
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains Guitarix's Development documentation.

Package: libgxw0
Section: libs
Architecture: any
Breaks: guitarix (<< 0.35)
Replaces: guitarix (<< 0.35)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Guitarix - GTK+ library
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains Guitarix's GTK+ library.

Package: libgxw-dev
Section: libdevel
Architecture: any
Depends: libgxw0 (= ${binary:Version}), ${misc:Depends}
Recommends: guitarix-doc
Description: Guitarix - GTK+ library (development files)
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains development files for Guitarix's GTK+ library.

Package: libgxwmm0
Section: libs
Architecture: any
Breaks: guitarix (<< 0.35)
Replaces: guitarix (<< 0.35)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Guitarix - GTK+ C++ widget library
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains Guitarix's GTK+ C++ widget library.

Package: libgxwmm-dev
Section: libdevel
Architecture: any
Depends: libgxwmm0 (= ${binary:Version}), ${misc:Depends}
Recommends: guitarix-doc
Description: Guitarix - GTK+ C++ widget library (development files)
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains development files for Guitarix's GTK+ C++ widget library.

Package: gxw-glade
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Guitarix - GTK+ library Glade support
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains Guitarix's GTK+ library Glade support.
